#include "rod.h"
#include "vehicle.h"
#include "vehicletype.h"

using namespace Msp;

namespace R2C2 {

Rod3D::Rod3D(const Vehicle3D &v, unsigned r):
	VehiclePart3D(v, *v.get_type().get_rod_object(r)),
	rod(vehicle.get_vehicle().get_rod(r))
{ }

void Rod3D::update_matrix()
{
	matrix = vehicle.Object3D::get_matrix();

	matrix.translate(rod.position);
	if(rod.type->mirror_object)
		matrix.scale(1, -1, 1);
	matrix.rotate(rod.angle, 0, -1, 0);
}

} // namespace R2C2
