#include "rotatetool.h"

using namespace std;
using namespace Msp;
using namespace R2C2;

RotateTool::RotateTool(Designer &d, Input::Keyboard &k, Input::Mouse &m, const set<Object *> &o):
	Manipulator(d, k, m, o),
	origin(Geometry::atan2(ground_pointer.y-center.y, ground_pointer.x-center.x))
{ }

void RotateTool::pointer_motion()
{
	Angle a = Geometry::atan2(ground_pointer.y-center.y, ground_pointer.x-center.x);
	angle += a-origin;
	origin = a;

	Transform trans = Transform::rotation(angle, Vector(0, 0, 1));
	for(ObjectArray::iterator i=objects.begin(); i!=objects.end(); ++i)
	{
		i->object->set_position(center+trans.transform(i->original_position));
		i->object->set_rotation(angle+i->original_rotation);
	}
}
