#ifndef CLOCKDIALOG_H_
#define CLOCKDIALOG_H_

#include <msp/gltk/dialog.h>
#include <msp/gltk/entry.h>
#include <msp/gltk/indicator.h>
#include "libr2c2/clock.h"

class ClockWidget;
class Engineer;

class ClockDialog: public Msp::GLtk::Dialog, public sigc::trackable
{
private:
	R2C2::Clock &clock;
	Msp::GLtk::Entry *ent_rate;
	Msp::GLtk::Indicator *ind_stopped;
	Msp::GLtk::Entry *ent_hour;
	Msp::GLtk::Entry *ent_minute;

public:
	ClockDialog(Engineer &);

private:
	void minute_changed();
	void set_rate();
	void stop_clicked();
	void set_time();
};

#endif
