#ifndef LIBR2C2_CATALOGUE_H_
#define LIBR2C2_CATALOGUE_H_

#include <msp/datafile/collection.h>
#include <msp/datafile/collectionsource.h>
#include <msp/fs/path.h>
#include "layout.h"

namespace R2C2 {

class ObjectType;

class Catalogue: public Msp::DataFile::Collection
{
public:
	class Loader: public Msp::DataFile::Collection::Loader
	{
	private:
		Catalogue &cat;

	public:
		Loader(Catalogue &);
	private:
		void layout();
		void scale(float, float);
	};

	sigc::signal<void, Msp::DataFile::CollectionSource &> signal_source_added;

private:
	float scale;
	Layout layout;
	std::list<Msp::DataFile::CollectionSource *> sources;

public:
	Catalogue();

	void add_source(const Msp::FS::Path &);
	const std::list<Msp::DataFile::CollectionSource *> &get_sources() const { return sources; }

	float get_scale() const { return scale; }
	Layout &get_layout() { return layout; }
};

} // namespace R2C2

#endif
