#ifndef REMOTE_H_
#define REMOTE_H_

#include <gtkmm/main.h>
#include <gtkmm/window.h>
#include <gtkmm/box.h>
#include <msp/core/application.h>
#include "network/client.h"

class MainPanel;
class TrainPanel;

class Remote: public Msp::RegisteredApplication<Remote>
{
private:
	Msp::IO::EventDispatcher event_disp;
	R2C2::Catalogue catalogue;
	R2C2::Client client;
	Gtk::Main gtk;
	Gtk::Window window;
	Gtk::Box *panel_box;
	MainPanel *main_panel;
	std::vector<TrainPanel *> train_panels;

public:
	Remote(int argc, char **argv);

	const R2C2::Catalogue &get_catalogue() const { return catalogue; }
private:
	void tick();

	void train_added(R2C2::NetTrain &);
};

#endif
